from pyplasm import *


def House2D():
    wall = MKPOL([[[0,0],[8,0],[0,6],[8,6],[4,8]],[range(1,6)],[[1]]])
    door = CUBOID([2,4])
    window = CUBOID([1,2])
    return DIFFERENCE([wall, T(1)(2)(door), T([1,2])([5,2])(window)])

House3D = PROD([ House2D(), Q(5) ])

out = House3D

##out = T(1)(2)(CUBE(1))
##out = T([1,2,3])([0,2,0])(CUBE(1))


#//Translation/////////////////////////////


def triple (obj):
    transl = T(1)(12)
    return STRUCT([ obj, transl(obj), transl(transl(obj))])

def n_ple(n):
    def n_ple0 (obj):
        transl = T(1)(12)
        return STRUCT([obj, transl] * n)
    return n_ple0

def n_ple(n):
    def n_ple0(i):
        def n_ple1 (obj):
            transl = T(i)(12)
            return STRUCT([obj, transl] * n)
        return n_ple1
    return n_ple0



VIEW(n_ple(20)(3)(
        n_ple(20)(1)(House3D)))


#///Scaling///////////////////////////////


out = S([1,2])([0.5,0.5])(CIRCUMFERENCE(1)(32))
out = S([1,2])([0.5,1])(CIRCUMFERENCE(1)(32))
out = S(1)(0.5])(CIRCUMFERENCE(1)(32))

VIEW(out)
